#include <direct.h>
#include <string.h>
#include <stdio.h>

#include <stdinc.c>

#define MaxPathLen 260 

boolean done (char *fileName);
boolean search_drive (char *path, char *fileName, int attrib);
boolean _search_drive (char *path, char *fileName, int attrib, char *curDir, char *firstDir, boolean *goNext);
void instruct ();

void main (int i, char *argv[13]) {
  char curDir[MaxPathLen] = "\\", _curDir[MaxPathLen];
  unsigned len;
  boolean *goNext = false;
  char firstDir[MaxPathLen] = 0;

  if (strcmp (argv[1], "/?") == 0) {
    instruct ();
    return;
  }

  strupr (argv[1]);
             
  getcurdir (0, _curDir);
  strcat (curDir, _curDir);
  
  /*if the user imputs ".", "..", or "\", and the root directory is not the
    current directory, then goto that directory. */
  if (strcmp (argv[1], "\\") == 0 or done (argv[1])) {
    if (strcmp ("\\", curDir)) chdir (argv[1]);
    return;
  } 
  
  //sets _curDir = to last dir in curDir
  len = strlen (curDir);
  for (i = len; *(curDir + i - 1) != '\\' or len - i < 2; i--)
    *(_curDir + len - i) = *(curDir + i - 1);

  *(_curDir + len - i) = 0;
  strrev (_curDir);
  strcat (curDir, "\\");

  /*if you don't give a parameter to go, it assummes the current directory as
    as parameter, unless the current directory is the root directory, in which
    case it exits.*/
  if (strcmp (argv[1], 0) == 0) 
    if (strcmp (_curDir, "\\") == 0)
      exit (0);
    else
      argv[1] = _curDir;
  
  if (strcmp (_curDir, argv[1]) == 0) 
    _search_drive ("\\", argv[1], 0x0010, curDir, firstDir, goNext); 
  else 
    search_drive ("\\", argv[1], 0x0010);
}

boolean done (char *fileName) {
  if (strcmp (fileName, ".") == 0 or strcmp (fileName, "..") == 0) 
    return true;
  
  return false;
}

boolean search_drive (char *path, char *fileName, int attrib) {
  struct ffblk file;
  int found;
  char nextPath[MaxPathLen];

  strcat (path, "*");
  
  found = findfirst (path, &file, attrib);  
  *(path + strlen(path) - 1) = 0;  

  until (!done (file.ff_name) or found == -1)
    found = findnext (&file);
  
  for (;;) {
    if (found == -1) {
      if (strcmp (path, "\\") == 0)
        printf ("directory \"%s\" not found on drive %c\n", fileName, getdisk () + 65);
    
      return false;
    }

    strcpy (nextPath, path);
    strcat (nextPath, file.ff_name);
    strcat (nextPath, "\\");
    
    if (strcmp (file.ff_name, fileName) == 0) {
      *(nextPath + strlen (nextPath) - 1) = 0;
      chdir (nextPath);
      return true;
    } else
      if (search_drive (nextPath, fileName, attrib)) return true;
    
    do {
      found = findnext (&file);    
    } until (!done (file.ff_name) or found == -1);
  } 
}

boolean _search_drive (char *path, char *fileName, int attrib, char *curDir, char *firstDir, boolean *goNext) {
  struct ffblk file;
  int found;
  char nextPath[MaxPathLen];

  strcat (path, "*");
  
  found = findfirst (path, &file, attrib);  
  *(path + strlen(path) - 1) = 0;  

  until (!done (file.ff_name) or found == -1)
    found = findnext (&file);
  
  for (;;) {
    if (found == -1) {
      if (strcmp (path, "\\") == 0 and strcmp (curDir, firstDir) == 0)
        printf ("current directory is the only \"%s\" directory on drive %c\n", fileName, getdisk () + 65);
      else
        chdir (firstDir);

      return false;
    }

    strcpy (nextPath, path);
    strcat (nextPath, file.ff_name);
    strcat (nextPath, "\\");
    
    if (strcmp (file.ff_name, fileName) == 0) {
      if (strcmp (firstDir, 0) == 0)
        strcpy (firstDir, nextPath);

      if (*goNext) {
      *(nextPath + strlen (nextPath) - 1) = 0;
        chdir (nextPath);
        return true;
      }

      if (strcmp (nextPath, curDir) == 0) *goNext = true;
      if (_search_drive (nextPath, fileName, attrib, curDir, firstDir, goNext)) return true;
    } else
      if (_search_drive (nextPath, fileName, attrib, curDir, firstDir, goNext)) return true;
    
    do {
      found = findnext (&file);    
    } until (!done (file.ff_name) or found == -1);
  } 
}

void instruct () {
  printf ("go [directory] - Changes current directory to any specified directory\n");
  printf ("                 on the current drive\n");
  printf ("go [current directory] - Changes to next directory on the curent drive\n");
  printf ("                         with the same name as the current directory\n");
  printf ("go - Same as above\n");
  printf ("go [..] - Changes to parent directory\n");
  printf ("go [\\] - Changes to root directory\n");
}
